package org.jtag;

import java.io.*;
import java.util.*;

import org.jtag.io.*;
 

/**
 * Main class of JTag programm. Calls the mainWindow class
 * to display the JTag window.
 *
 */
public class JTag {

    /**
     * Specify maximum autosave time (999 seconds)
     *
     */
    static final int MAX_AUTOSAVE = 999;
 	
    /**
     * Main function of JTAG class.
     *
     * @param args			command line parameters (not used)
     */
    public static void main(String args[]) {
        Vector defaultVector = new Vector();

        defaultVector.add("Song title");
        defaultVector.add("Artist");
        defaultVector.add("Album");
        defaultVector.add("Year");
        defaultVector.add("Comment");
        defaultVector.add("Genre");
        defaultVector.add("Filename");
		
        mainWindow frame;
	 
        // Read in the preferences
        readPreferences readPrefs = new readPreferences(".jtagrc");
					
        frame = new mainWindow("JTag");

        // Now set the options
        if (readPrefs.mp3Player != null && readPrefs.mp3Player.length() > 0)
            frame.mMpPlayer = readPrefs.mp3Player;
	
        if (readPrefs.sepCharacter != null)
            frame.mSepCharacter = readPrefs.sepCharacter;
	
        if (readPrefs.outputList.size() == 0)
            frame.mOutputVector = defaultVector;
        else
            frame.mOutputVector = readPrefs.outputList;
		
        if (readPrefs.dbUser != null)
            frame.mDbUser = readPrefs.dbUser;
		
        if (readPrefs.dbURL != null)
            frame.mDbURL = readPrefs.dbURL;
		
        if (readPrefs.dbDriver != null)
            frame.mDbDriver = readPrefs.dbDriver;
		
        if (readPrefs.autoSave > MAX_AUTOSAVE)
            frame.aSaveInterval = MAX_AUTOSAVE;
        else
            frame.aSaveInterval = readPrefs.autoSave;
	 
        frame.doUI();
		
        frame.pack();
        frame.setVisible(true);
		 
    }
}
