package org.jtag.id3;

import java.io.*;
import java.util.*;
import javax.swing.*;

import org.jtag.mp3.*;


public class writeId3 {
    String mDirectory,
        mFilename,
        mTitle,
        mArtist,
        mAlbum,
        mYear,
        mComment,
        mGenre;
	       
    private JTextArea mTextArea;
    private int tagOffset = 128;
	
    public writeId3(String dir, String filename, String title,
        String artist, String album, String year,
        String comment, String genre) {
        mDirectory = new String(dir);
        mFilename = new String(filename);
        mTitle = new String(title);
        mArtist = new String(artist);
        mAlbum = new String(album);
        mYear = new String(year);
        mComment = new String(comment);
        mGenre = new String(genre);
   
        mTextArea = null;
   
        write();
    }
  
    public writeId3(JTextArea  parentTextArea, 
        String dir, String filename, String title,
        String artist, String album, String year,
        String comment, String genre) {
        mDirectory = new String(dir);
        mFilename = new String(filename);
        mTitle = new String(title);
        mArtist = new String(artist);
        mAlbum = new String(album);
        mYear = new String(year);
        mComment = new String(comment);
        mGenre = new String(genre);
   
        mTextArea = parentTextArea;
   
        write();
    }
  
    private void write() {
        try { 
            File fileObj = new File(mDirectory + "/" + mFilename);
            RandomAccessFile rwStream = new RandomAccessFile(fileObj, "rw");
   
            long fileLength = fileObj.length();
   
            mp3Info info = new mp3Info(mDirectory, mFilename);
   
            if (info.hasIdTag == false) {
                // go to end of file
                rwStream.seek(fileLength);
            } else {
                rwStream.seek(fileLength - tagOffset);
            }
    
            // Now write the fields
            // Write the TAG
            String tag = new String("TAG");

            rwStream.write(tag.getBytes());

            int len = 0;

            // Write the title
            len = 30 - mTitle.length();
            for (int fill = 0; fill < len; fill++)
                mTitle = mTitle + " ";
    
            rwStream.write(mTitle.getBytes());
     
            // Write the artist
            len = 30 - mArtist.length();
            for (int fill = 0; fill < len; fill++)
                mArtist = mArtist + " ";
    
            rwStream.write(mArtist.getBytes());
    
            // Write the album
            len = 30 - mAlbum.length();
            for (int fill = 0; fill < len; fill++)
                mAlbum = mAlbum + " ";
    
            rwStream.write(mAlbum.getBytes());
    
            // Write the year
            len = 4 - mYear.length();
            for (int fill = 0; fill < len; fill++)
                mYear = mYear + " ";
    
            rwStream.write(mYear.getBytes());
    
            // Write the comment
            len = 30 - mComment.length();
            for (int fill = 0; fill < len; fill++)
                mComment = mComment + " ";
    
            rwStream.write(mComment.getBytes());
    
            // Write the genre
            Integer genreNr;
    
            if ((mGenre.length() > 0) && (mGenre.compareTo(" ") != 0)) {
                Hashtable hash = new Hashtable();
                id3Genre cGenre = new id3Genre();

                hash = cGenre.returnHashtable();
                genreNr = (Integer) hash.get(mGenre);
            } else {
                genreNr = new Integer(255);
            } 
    
            rwStream.write(genreNr.byteValue());
    
            rwStream.close();
        } catch (Exception e) {
            if (mTextArea != null)
                mTextArea.append("Error syncing " + mFilename + ": " + e + "\r\n");
            else
                System.out.println("Error syncing " + mFilename + ": " + e);
        }
    }
} // End of class
