package org.jtag.io;

import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.event.ActionEvent;

import org.jtag.*;


/**
 * Implements autosave function.
 *
 */
public class autoSave implements Runnable {

    /**
     * Specifies autosave interval.
     *
     */
    public long interval;
	
    /** Specifies parent window.
     *
     */
    public mainWindow mParent;
    Thread thread;
	
    /**
     * Indicates if thread should stop execution <code>true</code>
     * or not <code>false</code>
     *
     */
    public boolean stop = false;
	
    /**
     * Constructor for setting up autosave function.
     *
     * @param time		Time in seconds to wait till autosaving
     * @param parent	Handle of parent window
     */
    public autoSave(long time, mainWindow parent) {
        interval = time * 1000;
        mParent = parent;
        thread = new Thread(this);
        //System.out.println("Starting thread..");
        thread.start();
    }
	
    /**
     * Thread for autosaving
     *
     */
    public void run() {
        //System.out.println("Thread started (interval = " + interval +" )");
        while (!stop) {
            try {
                thread.sleep(interval);
                //System.out.println("Saving...");
                // We do not save if interval has been changed
                if (mParent.mTable != null && !stop)
                    Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(new ActionEvent (mParent.dummySyncButton, ActionEvent.ACTION_PERFORMED, new String("Sync")));
            } catch (Exception e) {
                System.out.println(e);
            }
        }
    }
}
