package org.jtag.table;

import javax.swing.table.*;


public class JTagTableModel extends AbstractTableModel {
    final String[] columnNames;
    final Object[][] data; 
     
    public JTagTableModel(Object[][] pData, String[] pHeaders) {
        columnNames = pHeaders;
        data = pData;
    }
	
    public int getColumnCount() {
        return columnNames.length;
    }
        
    public int getRowCount() {
        return data.length;
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        //return data[row][col];
        return data[row][col];
    }
	
    /*
     * JTable uses this method to determine the default renderer/
     * editor for each cell.  
     */
    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }
	
    public boolean isCellEditable(int row, int col) {        
        return true;
    }

    public void setValueAt(Object value, int row, int col) {       
        data[row][col] = value;     
    }

} //End of class JTagTableModel
